/*global document: false, exports: false, require: false, console: false, postMessage: false, onMessage: false */
var ourPageRE = new RegExp("buglist\\.cgi\\?.*\\&tweak=1");
var howManyAtOnce = 10;
var login = "", password = "";

function Message(cmd, data) {
	console.log("7: document = " + document);
	this.cmd = cmd;
	this.data = data;
}

function log(msgStr) {
	postMessage(new Message("LogMessage", msgStr));
}

/**
 * central handler processing messages from the main script.
 */
onMessage = function onMessage(msg) {
	console.log("19: document = " + document);
	switch (msg.cmd) {
	case "RetDuplicatorID":
		log("This bug is a duplicate of bug " + msg.data);
		break;
	case "RetPassword":
		main();
		break;
	case "ReloadThePage":
		document.location.reload(true);
		break;
	case "Error":
		log(msg.data);
		break;
	case "Unhandled":
		break;
	default:
		console.error("Error: unknown RPC call " + msg.toSource());
	}
};

/**
 * get parameters of URL as an object (name, value)
 */
function getParamsFromURL (url) {
	console.log("45: document = " + document);
	var paramsArr = url.search.split("&");
    log("paramsArr = " + paramsArr.toSource());
    if (paramsArr.length < 1) {
        return {};
    }

    // get convert URL parameters to an Object
    var params = {}, s = [];
    paramsArr.forEach(function(par) {
        s = par.split('=');
        params[s[0]] = s[1];
    });
    return params;
};

/**
 * Get a bug no from URL ... fails with aliases
 * It should theoretically belong to bzpage.js, but we don't have
 * unit tests there yet, so keeping here.
 *
 * @param url String with URL to be analyzed
 * @return String with the bug ID (hopefully number, but not for aliases)
 */
function getBugNo(url) {
	console.log("70: document = " + document);
    var params = getParamsFromURL(url);
    if (params && params.id) {
        return params.id;
    }
}

/**
 * very page specific function to get bug ID# for a bug in the mass-change list
 *
 * @param el DOM Element
 * @return Number with ID# or 0 if something wrong happens.
 */
function getElementIDForElem(el) {
    var ID = 0;
    if (el.hasAttribute("name")) {
        var IDstr = /id_([0-9]*)/.exec(el.getAttribute("name"))[1];
        ID = parseInt(IDstr, 10);
    }
    return ID;
}

function duplicateOf() {
	console.log("duplicateOf: document = " + document);
    var testElem = document.querySelector("tr.bz_bugitem input[type='checkbox']:checked");
    if (!testElem) {
    	return null;
    }

    var id = getElementIDForElem(testElem);
	postMessage(new Message("GetDuplicatorID", {
		host: document.location.hostname,
		bugID: getBugNo(document.location)
	}));
}

/**
 *
 */
function createNewButton(where, id, value, cb) {
	console.log("110: document = " + document);
    var nameVal = "", type = "";

    if (typeof cb === 'function') {
        type = "button";
    } else {
        type = "text";
        nameVal = id;
    }

    var butt = document.createElement("input");
    butt.setAttribute("type", type);
    butt.setAttribute("value", value);
    butt.setAttribute("id", id);
    if (type === "text") {
        butt.setAttribute("name", nameVal);
        butt.setAttribute("size", 12);
    }

    where.parentNode.insertBefore(butt, where);
    where.parentNode.insertBefore(document.createTextNode("\u00A0"), where);

	console.log("Creating " + type + "with id " + id + " and event handler " + cb);

    if (type === "button") {
        butt.addEventListener("click", cb, false);
    }

    return butt;
}

/**
 * Picks the list of bugs to be closed, collects ID#s and calls deduplicate
 * to do actual work
 *
 * @return none
 */
function deduplicateFromTable() {
    var dupeIDstr = document.getElementById("dupeid_inp").value;
    if (!dupeIDstr) {
        return ;
    }
    var testElems = document.
        querySelectorAll("table.bz_buglist tr.bz_bugitem input[type='checkbox']:checked");

    var idsToClose = Array.map(testElems, function (elem) {
        return getElementIDForElem(elem);
    }, this);

	if (idsToClose.length > 0) {
		postMessage(new Message("DeDeduplicateQueue", {
			bugs: idsToClose,
			duplicator: dupeIDstr,
			login: login,
			password: password,
			hostname: document.location.hostname
		}));
	}
};

function main() {
	console.log("171: document = " + document);
	var origButton = document.getElementsByName("check_all")[0];
	// If there are no bugs found, there is no origButton
	if (origButton) {
		var inpActionButton = createNewButton(origButton.nextSibling,
			"dupeid_action", "Close DUPs", deduplicateFromTable);
		createNewButton(inpActionButton, "dupe_of", "Dup#", duplicateOf);
		createNewButton(inpActionButton, "dupeid_inp", "", "text");
	}
}

//-----------------------------------------------------------

// FIXME eliminate whole this ... it is loaded every time message is called.

// if (ourPageRE.test(tab.contentWindow.location.href))
console.log("185: location = " + document.location);

var location = document.location;
var locationSplitSearch = location.search.split("&");

// https://bugzilla.redhat.com/buglist.cgi?.*&tweak=1
if ((location.pathname === "/buglist.cgi") &&
	(locationSplitSearch[locationSplitSearch.length - 1] === "tweak=1")) {

	var headerDiv = document.getElementById("header");
console.log("195: document = " + document);

	/*
	// Protection against premature loading
	if (!headerDiv) {
		return null;
	}
	*/

	var loginArrDOM = headerDiv.
		getElementsByTagName("ul")[0].getElementsByTagName("li");
	var loginArr = loginArrDOM[loginArrDOM.length - 1].textContent.split("\n");
	login = loginArr[loginArr.length - 1].trim();

	if (login) {
		postMessage(new Message("GetPassword", {
			login: login,
			hostname: location.hostname
		}));
console.log("214: document = " + document);
	}
}
