var main = require("main");
var testPageMod = require("pagemod-test-helpers").testPageMod;
var self = require("self");

var theURL = "https://bugzilla.redhat.com/buglist.cgi?" +
    "field0-0-0=component&field1-0-0=longdesc&field1-0-1=attach_data.thedata&field1-0-2=status_whiteboard" +
    "&query_format=advanced&type0-0-0=regexp&type1-0-0=substring&type1-0-1=substring&type1-0-2=substring" +
    "&value0-0-0=firefox&value1-0-0=_XAllocID%3A%20Assertion%20%60ret%20!%3D%20inval_id%27%20failed.\n" +
    "&value1-0-1=_XAllocID%3A%20Assertion%20%60ret%20!%3D%20inval_id%27%20failed.\n" +
    "&value1-0-2=_XAllocID%3A%20Assertion%20%60ret%20!%3D%20inval_id%27%20failed.\n" +
    "&order=bug_status%2Cpriority%2Cassigned_to%2Cbug_id&tweak=1";
var JSONifiedMessage = '{"cmd":"testMessage","data":{"a":"first","b":"second"}}';

exports.ensureMessagesWork = function(test) {
    var msg = new main.Message("testMessage", { a: "first", b: "second" } );
    test.assertEqual(msg.cmd, "testMessage",
        "msg.cmd comes over well");
    test.assertEqual(msg.data.a, "first",
        "msg.data.a comes over well");
    test.assertEqual(msg.data.b, "second",
        "msg.data.b comes over well");
    test.assertEqual(JSON.stringify(msg), JSONifiedMessage,
        "JSONification of Message works as well");
};

exports.ensurePageLoadsWell = function(test) {
    testPageMod(test, theURL, [{
    include: [
        "https://bugzilla.redhat.com/buglist.cgi?*"],
    contentScriptWhen: 'ready',
    contentScriptFile: [
        self.data.url("pw-lib.js"),
        self.data.url("pageWorker.js")
    ],
    onAttach: function onAttach(worker, mod) {
        worker.on('message', function (msg) {
            main.messageHandler(worker, msg);
        });
    }
    }],
    function (win, done) {
        test.assertNotEqual(win.document.getElementById("dupe_of"),
            undefined, "test of loading the page");
        done();
    }, 30000);
};
